/*!
    \file    main.c
    \brief   GPIO running led demo

    \version 2024-12-20, V3.3.1, demo for GD32F4xx
*/

/*
    Copyright (c) 2024, GigaDevice Semiconductor Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

#include "gd32f4xx.h"
#include <stdio.h>
#include "rtthread.h"
#include "rtservice.h"
#include "drv_adc.h"
#include "mb85rc64.h"
#include "tmp75.h"
#include "drv_usart.h"

float voltage;
float current;
float current_origin;
char tiedian_id[3]={0};

#ifdef MDAX
uint32_t ctl_data = 0;
#endif

uint32_t primask;

uint16_t tmp_value = 0;

extern uint16_t USER_ADC_DMA_DATA_BUFF;//bsp_adc.c中定义的ADC数据接收数组

uint8_t g_ADCDataReady=0;//DMA传输完成ADC数据标志位


typedef struct _MB85TEST_ 
{
	char ttt;
	float ggg;
    float tmperature;
    uint8_t status;
}MB85TEST;

MB85TEST ttest;


#define MB85TEST_ADD	0x0400

/*!
    \brief      main function
    \param[in]  none
    \param[out] none
    \retval     none
*/
int main(void)
{
    // RT-Thread 内核初始化等操作...
        
    // 其他应用程序初始化代码...

    __enable_irq();
    gd32_usart_init();

    adc_init();
    temp75_gpio_init();


	//测试mb铁电读写
	memset(&ttest, 0, sizeof(ttest));
	// mb85rc64_page_write();
	mb85rc64_add_read(MB85TEST_ADD, (unsigned char *)&ttest, sizeof(ttest));
    ttest.status = 0;
	ttest.ttt++;
    if (ttest.ggg >= 1000)
    {
        ttest.ggg -= 2;
        ttest.ggg /= 3;
    }
    else
    {
        ttest.ggg += 2;
        ttest.ggg *= 3;
    }

	mb85rc64_page_write(MB85TEST_ADD, (unsigned char *)&ttest, sizeof(ttest));

    // 进入主循环或启动其他任务
    while (1) 
    {
        #ifdef DMAX
        ctl_data = DMA_CHCTL(DMAX, USER_DMA_ADC_CHANNEL);
        if (ctl_data == 33762576)
        {
            // dma_channel_enable								  (DMA1, USER_DMA_ADC_CHANNEL);
            ttest.status = 5;
        }        
        else if (ctl_data == 33762577)
        {
            ttest.status = 4;

        }


        __asm volatile("mrs %0, primask" : "=r"(primask));

		if(SET == g_ADCDataReady)
		{
			g_ADCDataReady = RESET;
			for(uint8_t i=0; i<CHANNEL_LENGTH; i++)
			{
                tmp_value = BSP_ADCDataAcquire(i);
                if (i == 0)
                {
                    voltage = tmp_value/ 4095.0 * 3.3;
                }
                else
                {
                    current = tmp_value/ 4095.0 * 3.3;
                }
			}
		}
        rt_thread_mdelay(250);
        #endif

        #ifndef ADC_MODE_2
        voltage = ptz_Voltage_collect_adc1_task();
        rt_thread_mdelay(500);
        
        current = ptz_Current_collect_adc1_task();
        rt_thread_mdelay(500);
        #endif

        #ifdef ADC_MODE_2
        adc_software_trigger_enable(ADCX, SEQUENCE_CHANNEL);// 软件触发使能 后续接读取
        #endif
		//测试mb铁电读写
        read_mb_id((uint8_t*)&tiedian_id);//读取铁电ID

		memset(&ttest, 0, sizeof(ttest));
		// mb85rc64_page_write();
		mb85rc64_add_read(MB85TEST_ADD, (unsigned char *)&ttest, sizeof(ttest));
    	ttest.tmperature = ptz_temperature_collect_tmp75_task();

        // usart_puts(ttest.ttt);
        // 主循环代码...
    }
}

#ifdef DMAX

/*
*****************************************************************************
*  函数名 : DMA1_Channel0_IRQHandler
*  功能说明: DMA_ADC中断服务回调函数
*  形   参 : 无
*  返回值 :  无
*****************************************************************************
*/
void DMA1_Channel0_IRQHandler(void)
{
    if(dma_interrupt_flag_get(DMA1, USER_DMA_ADC_CHANNEL, DMA_INT_FLAG_FTF)) {
        ttest.status = 1;
        dma_interrupt_flag_clear(DMA1, USER_DMA_ADC_CHANNEL, DMA_INT_FLAG_FTF);
        // 处理传输完成
    }
    
    if(dma_interrupt_flag_get(DMA1, USER_DMA_ADC_CHANNEL, DMA_INT_FLAG_HTF)) {
        ttest.status = 2;
        dma_interrupt_flag_clear(DMA1, USER_DMA_ADC_CHANNEL, DMA_INT_FLAG_HTF);
        // 处理半传输完成（如果使能了）
    }
    
    if(dma_interrupt_flag_get(DMA1, USER_DMA_ADC_CHANNEL, DMA_INT_FLAG_FEE)) {
        ttest.status = 3;
        dma_interrupt_flag_clear(DMA1, USER_DMA_ADC_CHANNEL, DMA_INT_FLAG_FEE);
        // 处理错误
    }
    if(dma_interrupt_flag_get(DMA1, USER_DMA_ADC_CHANNEL, DMA_INT_FLAG_TAE)) {
        ttest.status = 6;
        dma_interrupt_flag_clear(DMA1, USER_DMA_ADC_CHANNEL, DMA_INT_FLAG_TAE);
        // 处理错误
    }
}

#endif


#ifdef ADCX_IRQn
void ADC_IRQHandler()
{
    if(adc_interrupt_flag_get(ADCX, ADC_INT_FLAG_EOC)) {
        voltage = adc_inserted_data_read(ADCX, ADC_INSERTED_CHANNEL_0); // 读取注入组数据寄存器
        voltage = voltage / 4095.0 * 3.3;
        current = adc_inserted_data_read(ADCX, ADC_INSERTED_CHANNEL_1); // 读取注入组数据寄存器
        current = ((current / 4095.0  * 3.3) - 3.3 / 2) / 0.132;
        adc_interrupt_flag_clear(ADCX, ADC_INT_FLAG_EOC);
        // 处理传输完成
    }
}
#endif